@echo off

set testdir=tests

REM ****************************************************************
REM Ensure that stepl-make has been called before stepl-test is run.
if not exist stepl.exe (goto :NOMAKE)

REM **********************************************
REM First delete all the .out files and .txt files
del %testdir%\*.out
del %testdir%\*.txt

REM ****************************
REM Now run the stepl test files

stepl < %testdir%\test-andor1.stpl > %testdir%\test-andor1.out 2>&1
stepl < %testdir%\test-andor2.stpl > %testdir%\test-andor2.out 2>&1
stepl < %testdir%\test-andor3.stpl > %testdir%\test-andor3.out 2>&1
stepl < %testdir%\test-arr1.stpl > %testdir%\test-arr1.out 2>&1
stepl < %testdir%\test-arr2.stpl > %testdir%\test-arr2.out 2>&1
stepl < %testdir%\test-arith1.stpl > %testdir%\test-arith1.out 2>&1
stepl < %testdir%\test-arith2.stpl > %testdir%\test-arith2.out 2>&1
stepl < %testdir%\test-arith3.stpl > %testdir%\test-arith3.out 2>&1
stepl < %testdir%\test-builtin1.stpl > %testdir%\test-builtin1.out 2>&1
stepl < %testdir%\test-builtin2.stpl > %testdir%\test-builtin2.out 2>&1
stepl < %testdir%\test-builtin3.stpl > %testdir%\test-builtin3.out 2>&1
stepl < %testdir%\test-builtin4.stpl > %testdir%\test-builtin4.out 2>&1
stepl < %testdir%\test-builtin5.stpl > %testdir%\test-builtin5.out 2>&1
stepl < %testdir%\test-comment1.stpl > %testdir%\test-comment1.out 2>&1
stepl < %testdir%\test-func1.stpl > %testdir%\test-func1.out 2>&1
stepl < %testdir%\test-gcd.stpl > %testdir%\test-gcd.out 2>&1
stepl < %testdir%\test-hello.stpl > %testdir%\test-hello.out 2>&1
stepl < %testdir%\test-if1.stpl > %testdir%\test-if1.out 2>&1
stepl < %testdir%\test-if2.stpl > %testdir%\test-if2.out 2>&1
stepl < %testdir%\test-if3.stpl > %testdir%\test-if3.out 2>&1
stepl < %testdir%\test-if4.stpl > %testdir%\test-if4.out 2>&1
stepl < %testdir%\test-if5.stpl > %testdir%\test-if5.out 2>&1
stepl < %testdir%\test-if6.stpl > %testdir%\test-if6.out 2>&1
stepl < %testdir%\test-ops1.stpl > %testdir%\test-ops1.out 2>&1
stepl < %testdir%\test-ops2.stpl > %testdir%\test-ops2.out 2>&1
stepl < %testdir%\test-var1.stpl > %testdir%\test-var1.out 2>&1
stepl < %testdir%\test-while1.stpl > %testdir%\test-while1.out 2>&1
stepl < %testdir%\test-while2.stpl > %testdir%\test-while2.out 2>&1

REM ********************************************
REM Now verify the results are what was expected

set /p andor1= < %testdir%\test-andor1.out
set /p andor2= < %testdir%\test-andor2.out
set /p andor3= < %testdir%\test-andor3.out
set /p arr1= < %testdir%\test-arr1.out
set /p arr2= < %testdir%\test-arr2.out
set /p arith1= < %testdir%\test-arith1.out
set /p arith2= < %testdir%\test-arith2.out
set /p arith3= < %testdir%\test-arith3.out
set /p builtin1= < %testdir%\test-builtin1.txt
set /p builtin2= < %testdir%\test-builtin2.out
set /p builtin3= < %testdir%\test-builtin3.out
set /p builtin4= < %testdir%\test-builtin4.out
set /p builtin5= < %testdir%\test-builtin5.out
set /p comment1= < %testdir%\test-comment1.out
set /p func1= < %testdir%\test-func1.out
set /p gcd= < %testdir%\test-gcd.out
set /p hello= < %testdir%\test-hello.out
set /p if1= < %testdir%\test-if1.out
set /p if2= < %testdir%\test-if2.out
set /p if3= < %testdir%\test-if3.out
set /p if4= < %testdir%\test-if4.out
set /p if5= < %testdir%\test-if5.out
set /p if6= < %testdir%\test-if6.out
set /p ops1= < %testdir%\test-ops1.out
set /p ops2= < %testdir%\test-ops2.out
set /p var1= < %testdir%\test-var1.out
set /p while1= < %testdir%\test-while1.out
set /p while2= < %testdir%\test-while2.out

if %andor1% EQU 01110001 (echo passed: test-andor1) else (echo failed: test-andor1)
if %andor2% EQU 01110001 (echo passed: test-andor2) else (echo failed: test-andor2)
if %andor3% EQU 01110001 (echo passed: test-andor3) else (echo failed: test-andor3)
if %arr1% EQU 42 (echo passed: test-arr1) else (echo failed: test-arr1)
if %arr2% EQU hello (echo passed: test-arr2) else (echo failed: test-arr2)
if %arith1% EQU 42 (echo passed: test-arith1) else (echo failed: test-arith1)
if %arith2% EQU 4 (echo passed: test-arith2) else (echo failed: test-arith2)
if %arith3% EQU 4 (echo passed: test-arith3) else (echo failed: test-arith3)
if %builtin1% EQU yes (echo passed: test-builtin1) else (echo failed: test-builtin1)
if %builtin2% EQU yes (echo passed: test-builtin2) else (echo failed: test-builtin2)
if %builtin3% EQU yes (echo passed: test-builtin3) else (echo failed: test-builtin3)
if %builtin4% EQU no (echo passed: test-builtin4) else (echo failed: test-builtin4)
if %builtin5% EQU no (echo passed: test-builtin5) else (echo failed: test-builtin5)
if %comment1% EQU yes (echo passed: test-comment1) else (echo failed: test-comment1)
if %func1% EQU 42 (echo passed: test-func1) else (echo failed: test-func1) 
if %gcd% EQU 2311 (echo passed: test-gcd) else (echo failed: test-gcd)
if %hello% EQU hello42 (echo passed: test-hello) else (echo failed: test-hello) 
if %if1% EQU 4217 (echo passed: test-if1) else (echo failed: test-if1)
if %if2% EQU 4217 (echo passed: test-if2) else (echo failed: test-if2)
if %if3% EQU 17 (echo passed: test-if3) else (echo failed: test-if3)
if %if4% EQU 817 (echo passed: test-if4) else (echo failed: test-if4)
if %if5% EQU 456 (echo passed: test-if5) else (echo failed: test-if5)
if %if6% EQU 1 (echo passed: test-if6) else (echo failed: test-if6)
if %ops1% EQU 3-19910990199019900199109910099 (echo passed: test-ops1) else (echo failed: test-ops1)
if %ops2% EQU 120110 (echo passed: test-ops2) else (echo failed: test-ops2)
if %var1% EQU 42 (echo passed: test-var1) else (echo failed: test-var1)
if %while1% EQU 5432142 (echo passed: test-while1) else (echo failed: test-while1)
if %while2% EQU 1 (echo passed: test-while2) else (echo failed: test-while2)

REM **********************************************
REM Delete all the .out files and .txt files
del %testdir%\*.out
del %testdir%\*.txt

GOTO :END

:NOMAKE
echo.
echo Please run stepl-make before running stepl-test

:END

echo on
